rm(list=ls())
setwd("/Users/BSS/Documents/7.Research/Cluster_Stability_Final/package 3")

source("A0_Functions.R")

######################################################

load('data_EX3.Rdata')

img.01 = draw.obs7(d1,as.matrix(y1), title="Ground Truth") # noisy_circles (V)
img.02 = draw.obs7(d2,as.matrix(y2)) # noisy_moons (V)
img.03 = draw.obs7(d3,as.matrix(y3)) # blobs
img.04 = draw.obs7(d4,1) # no_structure
img.05 = draw.obs7(d5,as.matrix(y5)) # Anisotropicly distributed data (V)
img.06 = draw.obs7(d6,as.matrix(y6)) # blobs with varied variances (V)

########################################################
#### Generate Data
########################################################
#set.seed(1200)
#set.seed(2018)
#set.seed(2050)

draw.obs7(d5,as.matrix(y5),title="Ground Truth",xlab="(a)")

########################################################
#### Draw whole sample plots
########################################################
C=3;G=3;E=0.24
X = d5
#set.seed(21)
K = kclst(X,X)
M = mclst(X,X)
D = dclst(X,X)
H = hclst(X,X)

i=5
X = eval(parse(text=paste("d", i, sep="")))
load(file=paste("zbdata_d",i,".Rdata",sep=""))
assign(paste("img.k",i,sep=""),draw.obs7(X,K))
assign(paste("img.m",i,sep=""),draw.obs7(X,M))
assign(paste("img.d",i,sep=""),draw.obs7(X,D))
assign(paste("img.h",i,sep=""),draw.obs7(X,H))

library(gridExtra)
g = grid.arrange(
  grobs = list(img.01,img.02,img.05,img.06,
               img.k1,img.k2,img.k5,img.k6,
               img.m1,img.m2,img.m5,img.m6,
               img.d1,img.d2,img.d5,img.d6,
               img.h1,img.h2,img.h5,img.h6,
               textGrob("Ground truth"),textGrob("K-means"),textGrob("Mclust"),textGrob("DBSCAN"),textGrob("hclust")),
  widths = c(1, 1, 1, 1, 1),
  heights = c(0.2,1,1,1,1),
  layout_matrix = rbind(c(21,22,23,24,25),
                        c(1,5, 9,13,17),
                        c(2,6,10,14,18),
                        c(3,7,11,15,19),
                        c(4,8,12,16,20))
)

save(img.01,img.02,img.05,img.06,
     img.k1,img.k2,img.k5,img.k6,
     img.m1,img.m2,img.m5,img.m6,
     img.d1,img.d2,img.d5,img.d6,
     img.h1,img.h2,img.h5,img.h6,
     file="img_wholedata.RD")


ggsave("EX3a.jpeg",width=200,height=100,units="mm",g)
########################################################
#### Generate Bootstrap samples
########################################################

zb.k = GenBsSamps(X,100,kclst)
zb.m = GenBsSamps(X,100,mclst)
zb.d = GenBsSamps(X,100,dclst)
zb.h = GenBsSamps(X,100,hclst)

#save(C,G,E,K,M,D,H,zb.k,zb.m,zb.d,zb.h, file="zbdata_d5.Rdata")
load(file="zbdata_d5.Rdata")

########################################################
#### Alignment
########################################################

#zb.align.k = align(zb.k$Z,100,folder="Kcls_jan08")
#zb.align.m = align(zb.m$Z,100,folder="Mcls_jan08")

id.k = align2(zb.k$Z,100,folder="Kcls_jan08")
id.m = align2(zb.m$Z,100,folder="Mcls_jan08")
id.d = align2(zb.d$Z,100,folder="Mcls_jan08")
id.h = align2(zb.h$Z,100,folder="Mcls_jan08")
########################################################
#### Find representative
########################################################

repre.k = Repre2(zb.k$Z, 100, id.k$idx)
repre.m = Repre2(zb.m$Z, 100, id.m$idx)
repre.d = Repre2(zb.d$Z, 100, id.d$idx)
repre.h = Repre2(zb.h$Z, 100, id.h$idx)

#save(repre.k,repre.m,repre.d,repre.h,file="zbrepre_d5.Rdata")
load("zbrepre_d5.Rdata")

i=6
X = eval(parse(text=paste("d", i, sep="")))
load(file=paste("zbrepre_d",i,".Rdata",sep=""))
assign(paste("imr.k",i,sep=""),draw.obs7(X,repre.k$repre))
assign(paste("imr.m",i,sep=""),draw.obs7(X,repre.m$repre))
assign(paste("imr.d",i,sep=""),draw.obs7(X,repre.d$repre))
assign(paste("imr.h",i,sep=""),draw.obs7(X,repre.h$repre))

library(gridExtra)
g = grid.arrange(
  grobs = list(img.01,img.02,img.05,img.06,
               imr.k1,imr.k2,imr.k5,imr.k6,
               imr.m1,imr.m2,imr.m5,imr.m6,
               imr.d1,imr.d2,imr.d5,imr.d6,
               imr.h1,imr.h2,imr.h5,imr.h6,
               textGrob("Ground truth"),textGrob("K-means"),textGrob("Mclust"),textGrob("DBSCAN"),textGrob("hclust")),
  widths = c(1, 1, 1, 1, 1),
  layout_matrix = rbind(c(21,22,23,24,25),
                        c(1,5, 9,13,17),
                        c(2,6,10,14,18),
                        c(3,7,11,15,19),
                        c(4,8,12,16,20))
)


ggsave("EX3aa.jpeg",width=190,height=120,units="mm",g)


########################################################
#### Find statistics
########################################################

repre.k$summary[,c(3,5,7,9)]/100
repre.m$summary[,c(3,5,7,9)]/100
repre.d$summary[,c(3,5,7,9)]/100
repre.h$summary[,c(3,5,7,9)]/100

########################################################
#### Confidence set
########################################################

draw.obs7(X,repre.k$confset[[1]])
draw.obs7(X,repre.k$confset[[2]])
draw.obs7(X,repre.k$confset[[3]])

draw.obs7(X,repre.m$confset[[5]])
draw.obs7(X,repre.m$confset[[2]])
draw.obs7(X,repre.m$confset[[3]])

draw.obs7(X,repre.d$confset[[1]])
draw.obs7(X,repre.d$confset[[2]])
draw.obs7(X,repre.d$confset[[3]])

draw.obs7(X,repre.h$confset[[1]])
draw.obs7(X,repre.h$confset[[2]])
draw.obs7(X,repre.h$confset[[3]])

g2 = grid.arrange(
  grobs = list(cf1,cf2,cf3,cf4),
  widths = c(1, 1, 1, 1),
  layout_matrix = rbind(c(1, 2, 3, 4))
)
ggsave("EX1_cf.jpeg",width=190,height=50,units="mm",g2)

repre.m$summary
round(t(bbb%*%as.matrix(repre.m$summary[,c(11,12,13,14)])),3)

########################################################
#### Find overall clustering stability - entropy
########################################################

i=6
X = eval(parse(text=paste("d", i, sep="")))
load(file=paste("zbrepre_d",i,".Rdata",sep=""))
assign(paste("ovs.k",i,sep=""), round(mean(repre.k$dist[,2]),4))
assign(paste("ovs.m",i,sep=""), round(mean(repre.m$dist[,2]),4))
assign(paste("ovs.d",i,sep=""), round(mean(repre.d$dist[,2]),4))
assign(paste("ovs.h",i,sep=""), round(mean(repre.h$dist[,2]),4))

round(rbind(c(ovs.k1, ovs.m1, ovs.d1, ovs.h1),
      c(ovs.k2, ovs.m2, ovs.d2, ovs.h2),
      c(ovs.k5, ovs.m5, ovs.d5, ovs.h5),
      c(ovs.k6, ovs.m6, ovs.d6, ovs.h6)),3)
