kclst2 <- function(X, newdata){
  kcl = flexclust::kcca(X, k=C, flexclust::kccaFamily("kmeans"))
  res = flexclust::predict(kcl, newdata=newdata)
  return(res)
}

kclst <- function(X, newdata){
  kcl = kmeans(X, C)
  res = as.numeric(class::knn(X,newdata,kcl$cluster))
  return(res)
}

mclst <- function(X, newdata){
  mcl = mclust::Mclust(X, G=C)
  res = predict(mcl, newdata=newdata)$classification
  return(res)
}

hclst <- function(X, newdata){
  hcl = hclust(dist(X))
  res = as.numeric(class::knn(X,newdata,cutree(hcl,C)))
  return(res)
}  

dclst <- function(X, newdata){
  dcl = dbscan::dbscan(X, eps=E)
  res = predict(dcl, newdata=newdata, data=X)
  return(res)
}

pclst <- function(X, newdata){
  pcl <- pcaReduce::PCAreduce(X, nbt=1, q=30, method='S')
  col.ind = which(apply(pcl[[1]],2,function(x) length(unique(x))) == C)
  res = as.numeric(class::knn(X,newdata,pcl[[1]][,col.ind]))
  return(res)
}

hmmvb <- function(X, newdat){
  HMM_1 = new("HMMVB", ndim = dim(X)[2], nseq = NVB, ndim_seq = DSQ, ncom_seq = CSQ,
              c_path = directory_HMMVB)
  HMMVB::estimate(HMM_1, data = X, diagonal_flag = TRUE)
  res = HMMVB::cluster(HMM_1, newdat)
  return(res)
}

hmmvb2 <- function(X, newdat){
  wd=getwd()
  setwd(directory_HMMVB)
  
  HMM_1 = new("HMMVB", ndim = dim(X)[2], nseq = NVB, ndim_seq = DSQ, ncom_seq = CSQ,
              c_path = directory_HMMVB)
  
  HMMVB::write_hyper_file(HMM_1)
  HMMVB::WriteData(HMM_1,X,"Train_data.txt")
  HMMVB::WriteData(HMM_1,newdat,"Test_data.txt")
  system(paste("./trainmaster -i Train_data.txt -m model_binary.dat -b hyperparam_HMMVB.dat -v", sep=""))
  system(paste("./testsync -i Test_data.txt -m model_binary.dat -o refcls.dat -t 0.3 -u -l 11", sep=""))
  res = c(as.matrix(read.table("refcls.dat", skip=1)))
  
  setwd(wd)
  
  return(res)
}
