% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/OTAcluster.R
\docType{package}
\name{OTAcluster-package}
\alias{OTAcluster}
\alias{OTAcluster-package}
\title{Mean Partition and Uncertainty Assessment of Clustering Analysis by Optimal Transport Alignment(OTA)}
\description{
\pkg{OTAcluster} is an R package for computing mean partition of ensemble of partitions by optimal transport alignment (OTA) and both partition-wise and cluster-wise uncertainty measures, including topological relationship between clusters in a partition, Confidence Point Set (CPS), Cluster Alignment and Points based (CAP) separability, and Wasserstein distance between partitions.
For a quick introduction to OTAcluster see the vignette A quick tour of \pkg{OTAcluster}.
}
\examples{
# set OTA package directory and compile C code.
SetOTA(directory)
set.seed(2070)
dat = GenData(n=5000,p=2,C=4)
# set parameters for 'kmeans' method in GenBsSamps.
C=4 
bs.samps = GenBsSamps(dat$X,100,"kmeans")
# find mean partition and uncertainty statistics.
idx = align2(bs.samps$Z,100)
res = MeanPart(bs.samps$Z, 100, idx)
# plot the result on two dimensional space.
plot.part(dat$X,dat$z)          # ground truth
plot.part(dat$X,kmeans(dat$X,C)$cluster)  # baseline method
plot.part(dat$X,res$repre)      # OTA
# distance between ground truth and each partition
WassDist(c(dat$z,kmeans(dat$X,C)$cluster,res$repre),3)
}
\author{
\strong{Maintainer}: Beomseok Seo \email{bzs32@psu.edu}

Authors:
\itemize{
  \item Jia Li \email{jiali@psu.edu}
  \item Lin Lin \email{llin@psu.edu}
}

}
