% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_part2.R
\name{plot_part2}
\alias{plot_part2}
\title{Visulize a partition on 2 dimensional space with convex hull}
\usage{
plot_part2(X, K, title = "", xlab = "", ylab = "", legend.title = "")
}
\arguments{
\item{X}{Cordinates matrix of data.}

\item{K}{Cluster labels of data.}
}
\value{
none
}
\description{
This function plots a partition on 2 dimensional reduced space with convex hull.
}
\examples{
# set OTA package directory and compile C code.
SetOTA(directory)
set.seed(2070)
dat = GenData(n=5000,p=2,C=4)
# set parameters for 'kmeans' method in GenBsSamps.
C=4 
bs.samps = GenBsSamps(dat$X,100,"kmeans")
# find mean partition and uncertainty statistics.
idx = align2(bs.samps$Z,100)
res = MeanPart(bs.samps$Z, 100, idx)
# plot the result on two dimensional space.
plot.part(dat$X,dat$z)          # ground truth
plot.part(dat$X,kmeans(dat$X,C)$cluster)  # baseline method
plot.part(dat$X,res$repre)      # OTA
# distance between ground truth and each partition
WassDist(c(dat$z,kmeans(dat$X,C)$cluster,res$repre),3)
}
